//-----------------------------------------------------------
//
//-----------------------------------------------------------
class LaserGun expands minigun2;

#exec texture import name=greymuz1 file=d:\unrealtournament\rainbowshockrifle\muz1.pcx
#exec texture import name=greymuz2 file=d:\unrealtournament\rainbowshockrifle\muz2.pcx
#exec texture import name=greymuz3 file=d:\unrealtournament\rainbowshockrifle\muz3.pcx
#exec texture import name=greymuz4 file=d:\unrealtournament\rainbowshockrifle\muz4.pcx
#exec texture import name=greymuz5 file=d:\unrealtournament\rainbowshockrifle\muz5.pcx
#exec texture import name=greymuz6 file=d:\unrealtournament\rainbowshockrifle\muz6.pcx
#exec texture import name=greymuz7 file=d:\unrealtournament\rainbowshockrifle\muz7.pcx
#exec texture import name=greymuz8 file=d:\unrealtournament\rainbowshockrifle\muz8.pcx
#exec texture import name=greymuz9 file=d:\unrealtournament\rainbowshockrifle\muz9.pcx
#exec texture import name=greymuzzy file=d:\unrealtournament\rainbowshockrifle\muzzy.pcx

var() int HitDamage;
var int BeamColor;
var vector OwnerLocation;
var float StillTime, StillStart;

simulated event RenderOverlays( canvas Canvas )
{
	local UT_Shellcase s;
	local vector X,Y,Z;
	local float dir;

	if ( bSteadyFlash3rd )
	{
		bMuzzleFlash = 1;
		bSetFlashTime = false;
		if ( !Level.bDropDetail )
			MFTexture = MuzzleFlashVariations[Rand(10)];
		else
			MFTexture = MuzzleFlashVariations[Rand(5)];
	}
	else
		bMuzzleFlash = 0;
	FlashY = Default.FlashY * (1.08 - 0.16 * FRand());
	if ( !Owner.IsA('PlayerPawn') || (PlayerPawn(Owner).Handedness == 0) )
		FlashO = Default.FlashO * (4 + 0.15 * FRand());
	else
		FlashO = Default.FlashO * (1 + 0.15 * FRand());
	Texture'MiniAmmoled'.NotifyActor = Self;
	Super.RenderOverlays(Canvas);
	Texture'MiniAmmoled'.NotifyActor = None;

	if ( bSteadyFlash3rd && Level.bHighDetailMode && (Level.TimeSeconds - LastShellSpawn > 0.125)
		&& (Level.Pauser=="") )
	{
		LastShellSpawn = Level.TimeSeconds;
		GetAxes(Pawn(Owner).ViewRotation,X,Y,Z);

		if ( PlayerViewOffset.Y >= 0 )
			dir = 1;
		else
			dir = -1;
		if ( Level.bHighDetailMode )
		{
			s = Spawn(class'invisibleshell',Owner, '', Owner.Location + CalcDrawOffset() + 30 * X + (0.4 * PlayerViewOffset.Y+5.0) * Y - Z * 5);
			if ( s != None )
				s.Eject(((FRand()*0.3+0.4)*X + (FRand()*0.3+0.2)*dir*Y + (FRand()*0.3+1.0) * Z)*160);
		}
	}
}

simulated function bool ClientAltFire( float Value )
{
	GotoState('Zooming');
	return true;
}

function AltFire( float Value )
{
	ClientAltFire(Value);
}

function Timer()
{
	local actor targ;
	local float bestAim, bestDist;
	local vector FireDir;
	local Pawn P;

	bestAim = 0.95;
	P = Pawn(Owner);
	if ( P == None )
	{
		GotoState('');
		return;
	}
	if ( VSize(P.Location - OwnerLocation) < 6 )
		StillTime += FMin(2.0, Level.TimeSeconds - StillStart);

	else
		StillTime = 0;
	StillStart = Level.TimeSeconds;
	OwnerLocation = P.Location;
	FireDir = vector(P.ViewRotation);
	targ = P.PickTarget(bestAim, bestDist, FireDir, Owner.Location);
	if ( Pawn(targ) != None )
	{
		SetTimer(1 + 4 * FRand(), false);
		bPointing = true;
		Pawn(targ).WarnTarget(P, 200, FireDir);
	}
	else
	{
		SetTimer(0.4 + 1.6 * FRand(), false);
		if ( (P.bFire == 0) && (P.bAltFire == 0) )
			bPointing = false;
	}
}

state Zooming
{
	simulated function Tick(float DeltaTime)
	{
		if ( Pawn(Owner).bAltFire == 0 )
		{
			if ( (PlayerPawn(Owner) != None) && PlayerPawn(Owner).Player.IsA('ViewPort') )
				PlayerPawn(Owner).StopZoom();
			SetTimer(0.0,False);
			GoToState('Idle');
		}
	}

	simulated function BeginState()
	{
		if ( Owner.IsA('PlayerPawn') )
		{
			if ( PlayerPawn(Owner).Player.IsA('ViewPort') )
				PlayerPawn(Owner).ToggleZoom();
			SetTimer(0.2,True);
		}
		else
		{
			Pawn(Owner).bFire = 1;
			Pawn(Owner).bAltFire = 0;
			Global.Fire(0);
		}
	}
}

state NormalFire
{
	function Tick( float DeltaTime )
	{
		if (Owner==None)
			AmbientSound = None;
	}

	function AnimEnd()
	{
		if (Pawn(Owner).Weapon != self) GotoState('');
		else if (Pawn(Owner).bFire!=0 && AmmoType.AmmoAmount>0)
			Global.Fire(0);
		else if ( Pawn(Owner).bAltFire!=0 && AmmoType.AmmoAmount>0)
			Global.AltFire(0);
		else
			GotoState('FinishFire');
	}

	function BeginState()
	{
		AmbientGlow = 250;
		AmbientSound = FireSound;
		bSteadyFlash3rd = true;
		Super.BeginState();
	}

	function EndState()
	{
		bSteadyFlash3rd = false;
		AmbientGlow = 0;
		LightType = LT_None;
		AmbientSound = None;
		Super.EndState();
	}

Begin:
	Sleep(0.10);
	GenerateBullet();
	Goto('Begin');
}


function TraceFire( float Accuracy )
{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z, AimDir;
	local actor Other;

	Owner.MakeNoise(Pawn(Owner).SoundDampening);
	GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
	StartTrace = Owner.Location + CalcDrawOffset() + FireOffset.Y * Y + FireOffset.Z * Z;
	AdjustedAim = pawn(owner).AdjustAim(1000000, StartTrace, 2.75*AimError, False, False);
	EndTrace = StartTrace + Accuracy * (FRand() - 0.5 )* Y * 1000
		+ Accuracy * (FRand() - 0.5 ) * Z * 1000;
	AimDir = vector(AdjustedAim);
	EndTrace += (10000 * AimDir);
	Other = Pawn(Owner).TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);

	Count++;
	if ( Count == 4 )
	{
		Count = 0;
		if ( VSize(HitLocation - StartTrace) > 250 )

	}
	ProcessTraceHit(Other, HitLocation, HitNormal, vector(AdjustedAim),Y,Z);

}

function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local int i;
	local PlayerPawn PlayerOwner;

	if (Other==None)
	{
		HitNormal = -X;
		HitLocation = Owner.Location + X*10000.0;
	}

	PlayerOwner = PlayerPawn(Owner);
	if ( PlayerOwner != None )
		PlayerOwner.ClientInstantFlash( -0.4, vect(450, 190, 650));
    HurtRadius(hitDamage,110.0, MyDamageType,6000, HitLocation );
	SpawnEffect(HitLocation, Owner.Location + CalcDrawOffset() + (FireOffset.X + 20) * X + FireOffset.Y * Y + FireOffset.Z * Z);

	if ( ShockProj(Other)!=None )
	{
		AmmoType.UseAmmo(2);
		ShockProj(Other).SuperExplosion();
	}
	else
{
	switch(beamcolor)
	{
	case 1:
	Spawn(class'mh4ever.blueshockexplo',,, HitLocation+HitNormal*8,rotator(HitNormal));
    Spawn(class'mh4ever.smallbluewave',,, HitLocation+HitNormal*8,rotator(HitNormal));
    break;

	case 2:
	Spawn(class'mh4ever.purpleshockexplo',,, HitLocation+HitNormal*8,rotator(HitNormal));
    Spawn(class'mh4ever.smallshockwave',,, HitLocation+HitNormal*8,rotator(HitNormal));
    break;

    case 3:
	Spawn(class'mh4ever.goldshockexplo',,, HitLocation+HitNormal*8,rotator(HitNormal));
    Spawn(class'mh4ever.smallgoldwave',,, HitLocation+HitNormal*8,rotator(HitNormal));
    break;

    case 4:
	Spawn(class'mh4ever.greenshockexplo',,, HitLocation+HitNormal*8,rotator(HitNormal));
    Spawn(class'mh4ever.smallgreenwave',,, HitLocation+HitNormal*8,rotator(HitNormal));
    break;

    case 5:
	Spawn(class'mh4ever.sunshockexplo',,, HitLocation+HitNormal*8,rotator(HitNormal));
    Spawn(class'mh4ever.smallsunwave',,, HitLocation+HitNormal*8,rotator(HitNormal));
    break;

    case 6:
	Spawn(class'mh4ever.whiteshockexplo',,, HitLocation+HitNormal*8,rotator(HitNormal));
    Spawn(class'mh4ever.smallwhitewave',,, HitLocation+HitNormal*8,rotator(HitNormal));
    break;

    case 7:
    beamcolor=0;
	Spawn(class'mh4ever.redshockexplo',,, HitLocation+HitNormal*8,rotator(HitNormal));
    Spawn(class'mh4ever.smallredwave',,, HitLocation+HitNormal*8,rotator(HitNormal));
    break;
    }
 }

	if ( (Other != self) && (Other != Owner) && (Other != None) )
		Other.TakeDamage(HitDamage, Pawn(Owner), HitLocation, 60000.0*X, MyDamageType);
}


function SpawnEffect(vector HitLocation, vector SmokeLocation)
{
	local smallblueshockbeam Smoke;
	local SmallShockBeam smoke2;
	local smallgoldbeam smoke3;
	local smallgreenbeam smoke4;
	local smallsunbeam smoke5;
	local smallwhitebeam smoke6;
	local smallredbeam smoke7;
	local Vector DVector;
	local int NumPoints;
	local rotator SmokeRotation;

	DVector = HitLocation - SmokeLocation;
	NumPoints = VSize(DVector)/135.0;
	if ( NumPoints < 1 )
		return;
	SmokeRotation = rotator(DVector);
	SmokeRotation.roll = Rand(65535);
	beamcolor++;
	switch(beamcolor)
	{
	case 1:
	Smoke = Spawn(class'smallblueshockbeam',,,SmokeLocation,SmokeRotation);
	Smoke.MoveAmount = DVector/NumPoints;
	Smoke.NumPuffs = NumPoints - 1;
	break;

	case 2:
	Smoke2 = Spawn(class'smallshockbeam',,,SmokeLocation,SmokeRotation);
	Smoke.MoveAmount = DVector/NumPoints;
	Smoke.NumPuffs = NumPoints - 1;
	break;

	case 3:
	Smoke3 = Spawn(class'smallgoldbeam',,,SmokeLocation,SmokeRotation);
	Smoke.MoveAmount = DVector/NumPoints;
	Smoke.NumPuffs = NumPoints - 1;
	break;

	case 4:
	Smoke4 = Spawn(class'smallgreenbeam',,,SmokeLocation,SmokeRotation);
	Smoke.MoveAmount = DVector/NumPoints;
	Smoke.NumPuffs = NumPoints - 1;
	break;

    case 5:
	Smoke5 = Spawn(class'smallsunbeam',,,SmokeLocation,SmokeRotation);
	Smoke.MoveAmount = DVector/NumPoints;
	Smoke.NumPuffs = NumPoints - 1;
	break;

    case 6:
	Smoke6 = Spawn(class'smallwhitebeam',,,SmokeLocation,SmokeRotation);
	Smoke.MoveAmount = DVector/NumPoints;
	Smoke.NumPuffs = NumPoints - 1;
	break;

    case 7:
    beamcolor=0;
	Smoke7 = Spawn(class'smallredbeam',,,SmokeLocation,SmokeRotation);
	Smoke.MoveAmount = DVector/NumPoints;
	Smoke.NumPuffs = NumPoints - 1;
	break;
	}
}

simulated function PlayFiring()
{
	if ( PlayerPawn(Owner) != None )
		PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
	    PlayOwnedSound(FireSound, SLOT_None, Pawn(Owner).SoundDampening*4.0);
	PlayAnim('Shoot1',1 + 0.6 * FireAdjust, 0.05);
	AmbientGlow = 250;
	AmbientSound = FireSound;
	bSteadyFlash3rd = true;
}

defaultproperties
{
     hitdamage=15
     MuzzleFlashVariations(0)=Texture'MH4ever.greymuz1'
     MuzzleFlashVariations(1)=Texture'MH4ever.greymuz2'
     MuzzleFlashVariations(2)=Texture'MH4ever.greymuz3'
     MuzzleFlashVariations(3)=Texture'MH4ever.greymuz4'
     MuzzleFlashVariations(4)=Texture'MH4ever.greymuz5'
     MuzzleFlashVariations(5)=Texture'MH4ever.greymuz6'
     MuzzleFlashVariations(6)=Texture'MH4ever.greymuz7'
     MuzzleFlashVariations(7)=Texture'MH4ever.greymuz8'
     MuzzleFlashVariations(8)=Texture'MH4ever.greymuz9'
     MuzzleFlashVariations(9)=Texture'MH4ever.greymuz9'
     AmmoName=Class'MH4ever.PrismaticShockCore'
     MyDamageType=jolted
     FireSound=Sound'UnrealShare.ASMD.TazerFire'
     PickupMessage="You got the Lasergun."
     ItemName="Lasergun"
     LightHue=255
     LightSaturation=255
}
