//-----------------------------------------------------------
//
//-----------------------------------------------------------
class TestPulse expands pulsegun;

var float FireRotation;		   // current rotation of barrel
var float ProjStartOffset;	   // distance from center of fire to launch side shots
var float RotatePerFire;       // amount of rotation after each fire
var int modes;
replication
{
	reliable if (Role == ROLE_Authority)
		FireRotation;
}

state AltFiring
{
	function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn)
	{
		local Vector Orig, Start1, Start2, Start3, Start4, X,Y,Z, End1, End2, End3, End4, Offset1, Offset2;

        for (modes = 0; modes < 4; modes++)
        {
                Switch(modes)
             {

        case 1:

		Owner.MakeNoise(Pawn(Owner).SoundDampening);
		GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
		Orig = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
		AdjustedAim = pawn(owner).AdjustAim(ProjSpeed, Orig, AimError, True, bWarn);
		Offset1 = Sin(FireRotation) * Y * ProjStartOffset + Cos(FireRotation) * ProjStartOffset * Z;
		Offset2 = Sin(FireRotation + PI) * Y * ProjStartOffset + Cos(FireRotation + PI) * ProjStartOffset * Z;
		Start3 = Orig - (Offset2 * 0.5);
		End3 = (Start3 - Orig) * 1.00 + 300 * X;
		FireRotation += (PI * RotatePerFire);
        Spawn(ProjClass, , , Start3, Rotator(End3));
        break;

        case 2:
		Owner.MakeNoise(Pawn(Owner).SoundDampening);
		GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
		Orig = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
		AdjustedAim = pawn(owner).AdjustAim(ProjSpeed, Orig, AimError, True, bWarn);
		Offset1 = Sin(FireRotation) * Y * ProjStartOffset + Cos(FireRotation) * ProjStartOffset * Z;
		Offset2 = Sin(FireRotation + PI) * Y * ProjStartOffset + Cos(FireRotation + PI) * ProjStartOffset * Z;
		Start3 = Orig - (Offset2 * 0.5);
		End3 = (Start3 - Orig) * 1.00 + 300 * X;
		FireRotation += (PI * RotatePerFire);
        Spawn(Class'fireplasma', , , Start3, Rotator(End3));
        break;

        case 3:
		Owner.MakeNoise(Pawn(Owner).SoundDampening);
		GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
		Orig = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
		AdjustedAim = pawn(owner).AdjustAim(ProjSpeed, Orig, AimError, True, bWarn);
		Offset1 = Sin(FireRotation) * Y * ProjStartOffset + Cos(FireRotation) * ProjStartOffset * Z;
		Offset2 = Sin(FireRotation + PI) * Y * ProjStartOffset + Cos(FireRotation + PI) * ProjStartOffset * Z;
		Start3 = Orig - (Offset2 * 0.5);
		End3 = (Start3 - Orig) * 1.00 + 300 * X;
		FireRotation += (PI * RotatePerFire);
        Spawn(Class'waterplasma', , , Start3, Rotator(End3));
        break;
              }
        }

	}

	function Tick( float DeltaTime )
	{
		if (Owner==None)
			GotoState('Pickup');
	}

	function BeginState()
	{
		Super.BeginState();
		Angle = 0;
		AmbientGlow = 200;
	}

	function EndState()
	{
		PlaySpinDown();
		AmbientSound = None;
		AmbientGlow = 0;
		OldFlashCount = FlashCount;
		Super.EndState();
	}

Begin:
	Sleep(0.12);
	Finish();
}

state NormalFire
{
	ignores AnimEnd;

	function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn)
	{
		local Vector Orig, Start1, Start2, Start3, Start4, X,Y,Z, End1, End2, End3, End4, Offset1, Offset2;

		Owner.MakeNoise(Pawn(Owner).SoundDampening);
		GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
		Orig = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
		AdjustedAim = pawn(owner).AdjustAim(ProjSpeed, Orig, AimError, True, bWarn);
		Offset1 = Sin(FireRotation) * Y * ProjStartOffset + Cos(FireRotation) * ProjStartOffset * Z;
		Offset2 = Sin(FireRotation + PI) * Y * ProjStartOffset + Cos(FireRotation + PI) * ProjStartOffset * Z;
		Start3 = Orig - (Offset2 * 0.5);
		End3 = (Start3 - Orig) * 1.00 + 300 * X;
		FireRotation += (PI * RotatePerFire);
        Spawn(ProjClass, , , Start3, Rotator(End3));

    }

	function Tick( float DeltaTime )
	{
		if (Owner==None)
			GotoState('Pickup');
	}

	function BeginState()
	{
		Super.BeginState();
		Angle = 0;
		AmbientGlow = 200;
	}

	function EndState()
	{
		PlaySpinDown();
		AmbientSound = None;
		AmbientGlow = 0;
		OldFlashCount = FlashCount;
		Super.EndState();
	}

Begin:
	Sleep(0.15);
	Finish();
}

simulated function PlayAltFiring()
{
	FlashCount++;
	AmbientSound = FireSound;
	SoundVolume = Pawn(Owner).SoundDampening*255;
	LoopAnim( 'shootLOOP', 1 + 0.5 * FireAdjust, 0.0);
	bWarnTarget = (FRand() < 0.2);
}

function AltFire( float Value )
{
	if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if (AmmoType.UseAmmo(3))
	{
		GotoState('AltFiring');
		if ( PlayerPawn(Owner) != None )
			PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
		bPointing=True;
		PlayAltFiring();
		if ( !bRapidFire && (FiringSpeed > 0) )
			Pawn(Owner).PlayRecoil(FiringSpeed);
		    ProjectileFire(ProjectileClass, AltProjectileSpeed, bAltWarnTarget);
    }
	else
	{
		PlayIdleAnim();
		Log("DHC Debug : Shouldn't be firing!");
	}
}

state ClientAltFiring
{
	simulated function Tick( float DeltaTime )
	{
		if ( (Pawn(Owner) != None) && (Pawn(Owner).bFire != 0) )
			AmbientSound = FireSound;
		else
			AmbientSound = None;
	}

	simulated function AnimEnd()
	{
		if ( (AmmoType != None) && (AmmoType.AmmoAmount <= 0) )
		{
			PlaySpinDown();
			GotoState('');
		}
		else if ( !bCanClientFire )
			GotoState('');
		else if ( Pawn(Owner) == None )
		{
			PlaySpinDown();
			GotoState('');
		}
		else if ( Pawn(Owner).bAltFire != 0 )
			Global.ClientAltFire(0);
		else if ( Pawn(Owner).bFire != 0 )
			Global.ClientFire(0);
		else
		{
			PlaySpinDown();
			GotoState('');
		}
	}
}

defaultproperties
{
     ProjStartOffset=15.000000
     RotatePerFire=0.150000
     PickupMessage="You got a Test Pulse Gun"
     ItemName="Test Pulse Gun"
}
